`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\ud_cnt.v"


























































`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\timescale.v"
`timescale 1ns / 10ps


`line 59 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\ud_cnt.v"


module ud_cnt (clk, nReset, rst, cnt_en, ud, nld, d, q, rci, rco);
	
	parameter SIZE  = 8;
	parameter RESD  = {SIZE{1'b0}}; 

	
	input             clk;    
	input             nReset; 
	input             rst;    
	input             cnt_en; 
	input             ud;     
	input             nld;    
	input  [SIZE-1:0] d;      
	output [SIZE-1:0] q;      
	input             rci;    
	output            rco;    

	
	reg  [SIZE-1:0] Qi;  
	wire [SIZE:0]   val; 

	
	
	

	assign val = ud ? ( {1'b0, Qi} + rci) : ( {1'b0, Qi} - rci);

	always@(posedge clk or negedge nReset)
	begin
		if (~nReset)
			Qi <= #1 RESD;
		else if (rst)
			Qi <= #1 RESD;
		else	if (~nld)
			Qi <= #1 d;
		else if (cnt_en)
			Qi <= #1 val[SIZE-1:0];
	end

	
	assign q = Qi;
	assign rco = val[SIZE];
endmodule




`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_controller.v"

































































`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\timescale.v"
`timescale 1ns / 10ps


`line 66 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_controller.v"


module atahost_controller (clk, nReset, rst, irq, IDEctrl_rst, IDEctrl_IDEen, 
			PIO_cmdport_T1, PIO_cmdport_T2, PIO_cmdport_T4, PIO_cmdport_Teoc, PIO_cmdport_IORDYen, 
			PIOreq, PIOack, PIOa, PIOd, PIOq, PIOwe, 
			RESETn, DDi, DDo, DDoe, DA, CS0n, CS1n, DIORn, DIOWn, IORDY, INTRQ);
	
	
	
	parameter TWIDTH = 8;              
	
	parameter PIO_mode0_T1   = 6;      
	parameter PIO_mode0_T2   = 28;     
	parameter PIO_mode0_T4   = 2;      
	parameter PIO_mode0_Teoc = 23;     
	
	
	
	input  clk; 
	input  nReset; 
	input  rst; 
	
	output irq; 
	reg irq;
	
	
	input  IDEctrl_rst;
	input  IDEctrl_IDEen;

	
	input  [7:0] PIO_cmdport_T1;
	input  [7:0] PIO_cmdport_T2;
	input  [7:0] PIO_cmdport_T4;
	input  [7:0] PIO_cmdport_Teoc;
	input        PIO_cmdport_IORDYen;

	
	input         PIOreq; 
	output        PIOack; 
	input  [ 3:0] PIOa;   
	input  [15:0] PIOd;   
	output [15:0] PIOq;   
	input         PIOwe;  

	reg [15:0] PIOq;
	reg PIOack;

	
	output        RESETn;
	input  [15:0] DDi;
	output [15:0] DDo;
	output        DDoe;
	output [ 2:0] DA;
	output        CS0n;
	output        CS1n;
	output        DIORn;
	output        DIOWn;
	input         IORDY;
	input         INTRQ;

	reg        RESETn;
	reg [15:0] DDo;
	reg        DDoe;
	reg [ 2:0] DA;
	reg        CS0n;
	reg        CS1n;
	reg        DIORn;
	reg        DIOWn;

	
	
	

	reg dPIOreq;
	reg PIOgo;   
	wire PIOdone; 

	
	wire PIOdior, PIOdiow;
	wire PIOoe;

	
	wire              dstrb;
	wire [TWIDTH-1:0] T1, T2, T4, Teoc;
	wire              IORDYen;

	
	reg sIORDY;

	
	
	


	
	reg cIORDY;                               
	reg cINTRQ;                               

	always@(posedge clk)
	begin : synch_incoming
		cIORDY <= #1 IORDY;
		cINTRQ <= #1 INTRQ;

		sIORDY <= #1 cIORDY;
		irq    <= #1 cINTRQ;
	end

	
	always@(posedge clk or negedge nReset)
		if (~nReset)
			begin
				RESETn <= #1 1'b0;
				DIORn  <= #1 1'b1;
				DIOWn  <= #1 1'b1;
				DA     <= #1 0;
				CS0n	  <= #1 1'b1;
				CS1n	  <= #1 1'b1;
				DDo    <= #1 0;
				DDoe   <= #1 1'b0;
			end
		else if (rst)
			begin
				RESETn <= #1 1'b0;
				DIORn  <= #1 1'b1;
				DIOWn  <= #1 1'b1;
				DA     <= #1 0;
				CS0n	  <= #1 1'b1;
				CS1n	  <= #1 1'b1;
				DDo    <= #1 0;
				DDoe   <= #1 1'b0;
			end
		else
			begin
				RESETn <= #1 !IDEctrl_rst;
				DA     <= #1 PIOa[2:0];
				CS0n   <= #1 !( !PIOa[3] & PIOreq); 
				CS1n   <= #1 !(  PIOa[3] & PIOreq); 

				DDo    <= #1 PIOd;
				DDoe   <= #1 PIOoe;
				DIORn  <= #1 !PIOdior;
				DIOWn  <= #1 !PIOdiow;
			end


	
	
	
	
	
	
	always@(posedge clk)
		if (dstrb)
			PIOq <= #1 DDi;

	
	always @(posedge clk or negedge nReset)
		if (~nReset)
			begin
				dPIOreq <= #1 1'b0;
				PIOgo   <= #1 1'b0;
			end
		else if (rst)
			begin
				dPIOreq <= #1 1'b0;
				PIOgo   <= #1 1'b0;
			end
		else
			begin
				dPIOreq <= #1 PIOreq & !PIOack;
				PIOgo   <= #1 (PIOreq & !dPIOreq) & IDEctrl_IDEen;
			end

	
	assign T1      = PIO_cmdport_T1;
	assign T2      = PIO_cmdport_T2;
	assign T4      = PIO_cmdport_T4;
	assign Teoc    = PIO_cmdport_Teoc;
	assign IORDYen = PIO_cmdport_IORDYen;

	
	atahost_pio_tctrl #(TWIDTH, PIO_mode0_T1, PIO_mode0_T2, PIO_mode0_T4, PIO_mode0_Teoc)
		PIO_timing_controller (
			.clk(clk),
			.nReset(nReset),
			.rst(rst),
			.IORDY_en(IORDYen),
			.T1(T1),
			.T2(T2),
			.T4(T4),
			.Teoc(Teoc),
			.go(PIOgo),
			.we(PIOwe),
			.oe(PIOoe),
			.done(PIOdone),
			.dstrb(dstrb),
			.DIOR(PIOdior),
			.DIOW(PIOdiow),
			.IORDY(sIORDY)
		);

	always@(posedge clk)
		PIOack <= #1 PIOdone | (PIOreq & !IDEctrl_IDEen); 

endmodule


`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_pio_tctrl.v"





























































































`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\timescale.v"
`timescale 1ns / 10ps


`line 94 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_pio_tctrl.v"


module atahost_pio_tctrl(clk, nReset, rst, IORDY_en, T1, T2, T4, Teoc, go, we, oe, done, dstrb, DIOR, DIOW, IORDY);
	
	parameter TWIDTH = 8;
	parameter PIO_MODE0_T1   =  6;             
	parameter PIO_MODE0_T2   = 28;             
	parameter PIO_MODE0_T4   =  2;             
	parameter PIO_MODE0_Teoc = 23;             
	
	
	input clk; 
	input nReset; 
	input rst; 
	
	
	input IORDY_en;          
	input [TWIDTH-1:0] T1;   
	input [TWIDTH-1:0] T2;   
	input [TWIDTH-1:0] T4;   
	input [TWIDTH-1:0] Teoc; 

	
	input go; 
	input we; 

	
	output oe; 
	reg oe;
	output done; 
	output dstrb; 
	reg dstrb;

	
	output DIOR; 
	reg DIOR;
	output DIOW; 
	reg DIOW;
	input  IORDY; 


	
	
	
	
	wire [TWIDTH-1:0] T1_m0   = PIO_MODE0_T1;
	wire [TWIDTH-1:0] T2_m0   = PIO_MODE0_T2;
	wire [TWIDTH-1:0] T4_m0   = PIO_MODE0_T4;
	wire [TWIDTH-1:0] Teoc_m0 = PIO_MODE0_Teoc;

	
	
	
	reg busy, hold_go;
	wire igo;
	wire T1done, T2done, T4done, Teoc_done, IORDY_done;
	reg hT2done;

	
	
	

	
	
	always@(posedge clk or negedge nReset)
		if (~nReset)
			begin
				busy    <= #1 1'b0;
				hold_go <= #1 1'b0;
			end
		else if (rst)
			begin
				busy    <= #1 1'b0;
				hold_go <= #1 1'b0;
			end
		else
			begin
				busy    <= #1 (igo | busy) & !Teoc_done;
				hold_go <= #1 (go | (hold_go & busy)) & !igo;
			end

	assign igo = (go | hold_go) & !busy;

	
	ro_cnt #(TWIDTH, 1'b0, PIO_MODE0_T1)
		t1_cnt(
			.clk(clk),
			.rst(rst),
			.nReset(nReset),
			.cnt_en(1'b1),
			.go(igo),
			.d(T1),
			.q(),
			.done(T1done)
		);

	
	always@(posedge clk or negedge nReset)
		if (~nReset)
			begin
				DIOR <= #1 1'b0;
				DIOW <= #1 1'b0;
				oe   <= #1 1'b0;
			end
		else if (rst)
			begin
				DIOR <= #1 1'b0;
				DIOW <= #1 1'b0;
				oe   <= #1 1'b0;
			end
		else
			begin
				DIOR <= #1 (!we & T1done) | (DIOR & !IORDY_done);
				DIOW <= #1 ( we & T1done) | (DIOW & !IORDY_done);
				oe   <= #1 ( (we & igo) | oe) & !T4done;           
			end

	
	ro_cnt #(TWIDTH, 1'b0, PIO_MODE0_T2)
		t2_cnt(
			.clk(clk),
			.rst(rst),
			.nReset(nReset),
			.cnt_en(1'b1),
			.go(T1done),
			.d(T2),
			.q(),
			.done(T2done)
		);

	
	
	always@(posedge clk or negedge nReset)
		if (~nReset)
			hT2done <= #1 1'b0;
		else if (rst)
			hT2done <= #1 1'b0;
		else
			hT2done <= #1 (T2done | hT2done) & !IORDY_done;

	assign IORDY_done = (T2done | hT2done) & (IORDY | !IORDY_en);

	
	always@(posedge clk)
		dstrb <= #1 IORDY_done;

	
	ro_cnt #(TWIDTH, 1'b0, PIO_MODE0_T4)
		dhold_cnt(
			.clk(clk),
			.rst(rst),
			.nReset(nReset),
			.cnt_en(1'b1),
			.go(IORDY_done),
			.d(T4),
			.q(),
			.done(T4done)
		);

	assign done = T4done; 
                        

	
	ro_cnt #(TWIDTH, 1'b0, PIO_MODE0_Teoc)
		eoc_cnt(
			.clk(clk),
			.rst(rst),
			.nReset(nReset),
			.cnt_en(1'b1),
			.go(IORDY_done),
			.d(Teoc),
			.q(),
			.done(Teoc_done)
		);

endmodule


`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_top.v"





















































































`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\timescale.v"
`timescale 1ns / 10ps


`line 86 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_top.v"


module atahost_top (wb_clk_i, arst_i, wb_rst_i, wb_cyc_i, wb_stb_i, wb_ack_o, wb_err_o,
		wb_adr_i, wb_dat_i, wb_dat_o, wb_sel_i, wb_we_i, wb_inta_o,
		resetn_pad_o, dd_pad_i, dd_pad_o, dd_padoe_o, da_pad_o, cs0n_pad_o,
		cs1n_pad_o, diorn_pad_o, diown_pad_o, iordy_pad_i, intrq_pad_i);
	
	
	
	parameter ARST_LVL = 1'b0;                    

	parameter TWIDTH = 8;                         
	
	parameter PIO_mode0_T1   =  6;                
	parameter PIO_mode0_T2   = 28;                
	parameter PIO_mode0_T4   =  2;                
	parameter PIO_mode0_Teoc = 23;                

	
	
	

	
	input wb_clk_i;                               
	input arst_i;                                 
	input wb_rst_i;                               

	
	input        wb_cyc_i;                        
	input        wb_stb_i;                        
	output       wb_ack_o;                        
	output       wb_err_o;                        
	input  [6:2] wb_adr_i;                        
	                                              
	                                              
	                                              
	input  [31:0] wb_dat_i;                       
	output [31:0] wb_dat_o;                       
	input  [ 3:0] wb_sel_i;                       
	input         wb_we_i;                        
	output        wb_inta_o;                      

	
	output        resetn_pad_o;
	input  [15:0] dd_pad_i;
	output [15:0] dd_pad_o;
	output        dd_padoe_o;
	output [ 2:0] da_pad_o;
	output        cs0n_pad_o;
	output        cs1n_pad_o;

	output        diorn_pad_o;
	output        diown_pad_o;
	input         iordy_pad_i;
	input         intrq_pad_i;

	
	
	
	parameter [3:0] DeviceId = 4'h1;
	parameter [3:0] RevisionNo = 4'h0;

	
	
	

	
	wire        IDEctrl_IDEen, IDEctrl_rst;
	wire [ 7:0] PIO_cmdport_T1, PIO_cmdport_T2, PIO_cmdport_T4, PIO_cmdport_Teoc;
	wire        PIO_cmdport_IORDYen;

	wire        PIOack;
	wire [15:0] PIOq;

	wire irq; 


	
	
	

	
	
	wire arst_signal = arst_i ^ ARST_LVL;

	
	
	
	atahost_wb_slave #(DeviceId, RevisionNo, PIO_mode0_T1, 
			PIO_mode0_T2, PIO_mode0_T4, PIO_mode0_Teoc, 0, 0, 0)
	u0 (
		
		.clk_i(wb_clk_i),
		.arst_i(arst_signal),
		.rst_i(wb_rst_i),

		
		.cyc_i(wb_cyc_i),
		.stb_i(wb_stb_i),
		.ack_o(wb_ack_o),
		.rty_o(),
		.err_o(wb_err_o),
		.adr_i(wb_adr_i),
		.dat_i(wb_dat_i),
		.dat_o(wb_dat_o),
		.sel_i(wb_sel_i),
		.we_i(wb_we_i),
		.inta_o(wb_inta_o),

		
		.PIOsel(PIOsel),
			
			
			
		.PIOtip(1'b0),
		.PIOack(PIOack),
		.PIOq(PIOq),
		.PIOpp_full(1'b0), 
		.irq(irq),

		
		.DMAsel(),
		.DMAtip(1'b0),
		.DMAack(1'b0),
		.DMARxEmpty(1'b0),
		.DMATxFull(1'b0),
		.DMA_dmarq(1'b0),
		.DMAq(32'h0),

		
		
		.IDEctrl_rst(IDEctrl_rst),
		.IDEctrl_IDEen(IDEctrl_IDEen),
		.IDEctrl_FATR0(),
		.IDEctrl_FATR1(),
		.IDEctrl_ppen(),

		.DMActrl_DMAen(),
		.DMActrl_dir(),
		.DMActrl_BeLeC0(),
		.DMActrl_BeLeC1(),

		
		.PIO_cmdport_T1(PIO_cmdport_T1),
		.PIO_cmdport_T2(PIO_cmdport_T2),
		.PIO_cmdport_T4(PIO_cmdport_T4),
		.PIO_cmdport_Teoc(PIO_cmdport_Teoc),
		.PIO_cmdport_IORDYen(PIO_cmdport_IORDYen),

		
		.PIO_dport0_T1(),
		.PIO_dport0_T2(),
		.PIO_dport0_T4(),
		.PIO_dport0_Teoc(),
		.PIO_dport0_IORDYen(),

		
		.PIO_dport1_T1(),
		.PIO_dport1_T2(),
		.PIO_dport1_T4(),
		.PIO_dport1_Teoc(),
		.PIO_dport1_IORDYen(),

		
		.DMA_dev0_Tm(),
		.DMA_dev0_Td(),
		.DMA_dev0_Teoc(),

		
		.DMA_dev1_Tm(),
		.DMA_dev1_Td(),
		.DMA_dev1_Teoc()
	);


	
	
	
	atahost_controller #(TWIDTH, PIO_mode0_T1, PIO_mode0_T2, PIO_mode0_T4, PIO_mode0_Teoc)
		u1 (
			.clk(wb_clk_i),
			.nReset(arst_signal),
			.rst(wb_rst_i),
			.irq(irq),
			.IDEctrl_rst(IDEctrl_rst),
			.IDEctrl_IDEen(IDEctrl_IDEen),
			.PIO_cmdport_T1(PIO_cmdport_T1),
			.PIO_cmdport_T2(PIO_cmdport_T2),
			.PIO_cmdport_T4(PIO_cmdport_T4),
			.PIO_cmdport_Teoc(PIO_cmdport_Teoc),
			.PIO_cmdport_IORDYen(PIO_cmdport_IORDYen),
			.PIOreq(PIOsel),
			.PIOack(PIOack),
			.PIOa(wb_adr_i[5:2]),
			.PIOd(wb_dat_i[15:0]),
			.PIOq(PIOq),
			.PIOwe(wb_we_i),
			.RESETn(resetn_pad_o),
			.DDi(dd_pad_i),
			.DDo(dd_pad_o),
			.DDoe(dd_padoe_o),
			.DA(da_pad_o),
			.CS0n(cs0n_pad_o),
			.CS1n(cs1n_pad_o),
			.DIORn(diorn_pad_o),
			.DIOWn(diown_pad_o),
			.IORDY(iordy_pad_i),
			.INTRQ(intrq_pad_i)
		);

endmodule


`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_wb_slave.v"






















































`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\timescale.v"
`timescale 1ns / 10ps


`line 55 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\atahost_wb_slave.v"


module atahost_wb_slave (
		clk_i, arst_i, rst_i, cyc_i, stb_i, ack_o, rty_o, err_o, adr_i,	dat_i, dat_o, sel_i, we_i, inta_o,
		PIOsel, PIOtip, PIOack, PIOq, PIOpp_full, irq,
		DMAsel, DMAtip, DMAack, DMARxEmpty, DMATxFull, DMA_dmarq, DMAq,
		IDEctrl_rst, IDEctrl_IDEen, IDEctrl_FATR1, IDEctrl_FATR0, IDEctrl_ppen,
		DMActrl_DMAen, DMActrl_dir, DMActrl_BeLeC0, DMActrl_BeLeC1,
		PIO_cmdport_T1, PIO_cmdport_T2, PIO_cmdport_T4, PIO_cmdport_Teoc, PIO_cmdport_IORDYen,
		PIO_dport0_T1, PIO_dport0_T2, PIO_dport0_T4, PIO_dport0_Teoc, PIO_dport0_IORDYen,
		PIO_dport1_T1, PIO_dport1_T2, PIO_dport1_T4, PIO_dport1_Teoc, PIO_dport1_IORDYen,
		DMA_dev0_Tm, DMA_dev0_Td, DMA_dev0_Teoc, DMA_dev1_Tm, DMA_dev1_Td, DMA_dev1_Teoc
	);

	
	
	
	parameter DeviceId   = 4'h0;
	parameter RevisionNo = 4'h0;

	
	parameter PIO_mode0_T1   =  6;                
	parameter PIO_mode0_T2   = 28;                
	parameter PIO_mode0_T4   =  2;                
	parameter PIO_mode0_Teoc = 23;                

	
	parameter DMA_mode0_Tm   =  6;                
	parameter DMA_mode0_Td   = 21;                
	parameter DMA_mode0_Teoc = 21;                

	
	
	
	
	
	input clk_i;                                
	input arst_i;                               
	input rst_i;                                

	
	input       cyc_i;                          
	input       stb_i;                          
	output      ack_o;                          
	output      rty_o;                          
	output      err_o;                          
	input [6:2] adr_i;                          
	                                            
	                                            
	                                            
	input  [31:0] dat_i;                        
	output [31:0] dat_o;                        
	input  [ 3:0] sel_i;                        
	input         we_i;                         
	output        inta_o;                       

	
	output        PIOsel;
	input         PIOtip;                       
	input         PIOack;                       
	input  [15:0] PIOq;                         
	input         PIOpp_full;                   
	input         irq;                          

	
	output       DMAsel;
	input        DMAtip;                        
	input        DMAack;                        
	input        DMARxEmpty;                    
	input        DMATxFull;                     
	input        DMA_dmarq;                     
	input [31:0] DMAq;

	
	
	output IDEctrl_rst;
	output IDEctrl_IDEen;
	output IDEctrl_FATR1;
	output IDEctrl_FATR0;
	output IDEctrl_ppen;
	output DMActrl_DMAen;
	output DMActrl_dir;
	output DMActrl_BeLeC0;
	output DMActrl_BeLeC1;

	
	output [7:0] PIO_cmdport_T1,
	             PIO_cmdport_T2,
	             PIO_cmdport_T4,
	             PIO_cmdport_Teoc;
	output       PIO_cmdport_IORDYen;

	reg [7:0] PIO_cmdport_T1,
	          PIO_cmdport_T2,
	          PIO_cmdport_T4,
	          PIO_cmdport_Teoc;

	
	output [7:0] PIO_dport0_T1,
	             PIO_dport0_T2,
	             PIO_dport0_T4,
	             PIO_dport0_Teoc;
	output       PIO_dport0_IORDYen;

	reg [7:0] PIO_dport0_T1,
	          PIO_dport0_T2,
	          PIO_dport0_T4,
	          PIO_dport0_Teoc;

	
	output [7:0] PIO_dport1_T1,
	             PIO_dport1_T2,
	             PIO_dport1_T4,
	             PIO_dport1_Teoc;
	output       PIO_dport1_IORDYen;

	reg [7:0] PIO_dport1_T1,
	          PIO_dport1_T2,
	          PIO_dport1_T4,
	          PIO_dport1_Teoc;

	
	output [7:0] DMA_dev0_Tm,
	             DMA_dev0_Td,
	             DMA_dev0_Teoc;

	reg [7:0] DMA_dev0_Tm,
	          DMA_dev0_Td,
	          DMA_dev0_Teoc;

	
	output [7:0] DMA_dev1_Tm,
	             DMA_dev1_Td,
	             DMA_dev1_Teoc;

	reg [7:0] DMA_dev1_Tm,
	          DMA_dev1_Td,
	          DMA_dev1_Teoc;


	
	
	

	
	
	

	
	
	
	
	
	
	
	
	


	
	
	

	
	reg  [31:0] CtrlReg; 
	wire [31:0] StatReg; 

	
	reg store_pp_full;


	
	
	
	wire w_acc  = &sel_i[1:0];                        
	wire dw_acc = &sel_i;                             

	
	wire berr =  adr_i [ 6 ] ? !w_acc : !dw_acc;

	
	wire PIOsel = cyc_i & stb_i &  adr_i [ 6 ] & w_acc & !(DMAtip | store_pp_full);

	
	wire CONsel = cyc_i & stb_i & !( adr_i [ 6 ]) & dw_acc;
	wire DMAsel = CONsel & ( adr_i [ 5 : 2 ] ==  4'b1111);

	
	
	always@(posedge clk_i)
		if (!PIOsel)
			store_pp_full <= #1 PIOpp_full;

	wire brty = ( adr_i [ 6 ] & w_acc) & (DMAtip | store_pp_full);

	
	
	

	
	wire sel_ctrl        = CONsel & we_i & ( adr_i [ 5 : 2 ] ==  4'b0000);
	wire sel_stat        = CONsel & we_i & ( adr_i [ 5 : 2 ] ==  4'b0001);
	wire sel_PIO_cmdport = CONsel & we_i & ( adr_i [ 5 : 2 ] ==  4'b0010);
	wire sel_PIO_dport0  = CONsel & we_i & ( adr_i [ 5 : 2 ] ==  4'b0011);
	wire sel_PIO_dport1  = CONsel & we_i & ( adr_i [ 5 : 2 ] ==  4'b0100);
	wire sel_DMA_dev0    = CONsel & we_i & ( adr_i [ 5 : 2 ] ==  4'b0101);
	wire sel_DMA_dev1    = CONsel & we_i & ( adr_i [ 5 : 2 ] ==  4'b0110);
	
	


	
	always@(posedge clk_i or negedge arst_i)
		if (~arst_i)
			begin
				CtrlReg[31:1] <= #1 0;
				CtrlReg[0]    <= #1 1'b1; 
			end
		else if (rst_i)
			begin
				CtrlReg[31:1] <= #1 0;
				CtrlReg[0]    <= #1 1'b1; 
			end
		else if (sel_ctrl)
			CtrlReg <= #1 dat_i;

	
	assign DMActrl_DMAen        = CtrlReg[15];
	assign DMActrl_dir          = CtrlReg[13];
	assign DMActrl_BeLeC1       = CtrlReg[9];
	assign DMActrl_BeLeC0       = CtrlReg[8];
	assign IDEctrl_IDEen        = CtrlReg[7];
	assign IDEctrl_FATR1        = CtrlReg[6];
	assign IDEctrl_FATR0        = CtrlReg[5];
	assign IDEctrl_ppen         = CtrlReg[4];
	assign PIO_dport1_IORDYen   = CtrlReg[3];
	assign PIO_dport0_IORDYen   = CtrlReg[2];
	assign PIO_cmdport_IORDYen  = CtrlReg[1];
	assign IDEctrl_rst          = CtrlReg[0];


	
	reg dirq, int;
	
	always@(posedge clk_i or negedge arst_i)
		if (~arst_i)
			begin
				int  <= #1 1'b0;
				dirq <= #1 1'b0;
			end
		else if (rst_i)
			begin
				int  <= #1 1'b0;
				dirq <= #1 1'b0;
			end
		else
			begin
				int  <= #1 (int | (irq & !dirq)) & !(sel_stat & !dat_i[0]);
				dirq <= #1 irq;
			end

	
	assign StatReg[31:28] = DeviceId;   
	assign StatReg[27:24] = RevisionNo; 
	assign StatReg[23:16] = 0;          
	assign StatReg[15]    = DMAtip;
	assign StatReg[14:11] = 0;
	assign StatReg[10]    = DMARxEmpty;
	assign StatReg[9]     = DMATxFull;
	assign StatReg[8]     = DMA_dmarq;
	assign StatReg[7]     = PIOtip;
	assign StatReg[6]     = PIOpp_full;
	assign StatReg[5:1]   = 0;          
	assign StatReg[0]     = int;


	
	always@(posedge clk_i or negedge arst_i)
		if (~arst_i)
			begin
				PIO_cmdport_T1   <= #1 PIO_mode0_T1;
				PIO_cmdport_T2   <= #1 PIO_mode0_T2;
				PIO_cmdport_T4   <= #1 PIO_mode0_T4;
				PIO_cmdport_Teoc <= #1 PIO_mode0_Teoc;
			end
		else if (rst_i)
			begin
				PIO_cmdport_T1   <= #1 PIO_mode0_T1;
				PIO_cmdport_T2   <= #1 PIO_mode0_T2;
				PIO_cmdport_T4   <= #1 PIO_mode0_T4;
				PIO_cmdport_Teoc <= #1 PIO_mode0_Teoc;
			end
		else if(sel_PIO_cmdport)
			begin
				PIO_cmdport_T1   <= #1 dat_i[ 7: 0];
				PIO_cmdport_T2   <= #1 dat_i[15: 8];
				PIO_cmdport_T4   <= #1 dat_i[23:16];
				PIO_cmdport_Teoc <= #1 dat_i[31:24];
			end

	
	always@(posedge clk_i or negedge arst_i)
		if (~arst_i)
			begin
				PIO_dport0_T1   <= #1 PIO_mode0_T1;
				PIO_dport0_T2   <= #1 PIO_mode0_T2;
				PIO_dport0_T4   <= #1 PIO_mode0_T4;
				PIO_dport0_Teoc <= #1 PIO_mode0_Teoc;
			end
		else if (rst_i)
			begin
				PIO_dport0_T1   <= #1 PIO_mode0_T1;
				PIO_dport0_T2   <= #1 PIO_mode0_T2;
				PIO_dport0_T4   <= #1 PIO_mode0_T4;
				PIO_dport0_Teoc <= #1 PIO_mode0_Teoc;
			end
		else if(sel_PIO_dport0)
			begin
				PIO_dport0_T1   <= #1 dat_i[ 7: 0];
				PIO_dport0_T2   <= #1 dat_i[15: 8];
				PIO_dport0_T4   <= #1 dat_i[23:16];
				PIO_dport0_Teoc <= #1 dat_i[31:24];
			end

	
	always@(posedge clk_i or negedge arst_i)
		if (~arst_i)
			begin
				PIO_dport1_T1   <= #1 PIO_mode0_T1;
				PIO_dport1_T2   <= #1 PIO_mode0_T2;
				PIO_dport1_T4   <= #1 PIO_mode0_T4;
				PIO_dport1_Teoc <= #1 PIO_mode0_Teoc;
			end
		else if (rst_i)
			begin
				PIO_dport1_T1   <= #1 PIO_mode0_T1;
				PIO_dport1_T2   <= #1 PIO_mode0_T2;
				PIO_dport1_T4   <= #1 PIO_mode0_T4;
				PIO_dport1_Teoc <= #1 PIO_mode0_Teoc;
			end
		else if(sel_PIO_dport1)
			begin
				PIO_dport1_T1   <= #1 dat_i[ 7: 0];
				PIO_dport1_T2   <= #1 dat_i[15: 8];
				PIO_dport1_T4   <= #1 dat_i[23:16];
				PIO_dport1_Teoc <= #1 dat_i[31:24];
			end

	
	always@(posedge clk_i or negedge arst_i)
		if (~arst_i)
			begin
				DMA_dev0_Tm   <= #1 DMA_mode0_Tm;
				DMA_dev0_Td   <= #1 DMA_mode0_Td;
				DMA_dev0_Teoc <= #1 DMA_mode0_Teoc;
			end
		else if (rst_i)
			begin
				DMA_dev0_Tm   <= #1 DMA_mode0_Tm;
				DMA_dev0_Td   <= #1 DMA_mode0_Td;
				DMA_dev0_Teoc <= #1 DMA_mode0_Teoc;
			end
		else if(sel_DMA_dev0)
			begin
				DMA_dev0_Tm   <= #1 dat_i[ 7: 0];
				DMA_dev0_Td   <= #1 dat_i[15: 8];
				DMA_dev0_Teoc <= #1 dat_i[31:24];
			end

	
	always@(posedge clk_i or negedge arst_i)
		if (~arst_i)
			begin
				DMA_dev1_Tm   <= #1 DMA_mode0_Tm;
				DMA_dev1_Td   <= #1 DMA_mode0_Td;
				DMA_dev1_Teoc <= #1 DMA_mode0_Teoc;
			end
		else if (rst_i)
			begin
				DMA_dev1_Tm   <= #1 DMA_mode0_Tm;
				DMA_dev1_Td   <= #1 DMA_mode0_Td;
				DMA_dev1_Teoc <= #1 DMA_mode0_Teoc;
			end
		else if(sel_DMA_dev1)
			begin
				DMA_dev1_Tm   <= #1 dat_i[ 7: 0];
				DMA_dev1_Td   <= #1 dat_i[15: 8];
				DMA_dev1_Teoc <= #1 dat_i[31:24];
			end

	
	
	
	reg [31:0] Q;

	
	assign ack_o = PIOack | CONsel; 

	
	assign err_o = cyc_i & stb_i & berr;

	
	assign rty_o = cyc_i & stb_i & brty;

	
	assign inta_o = StatReg[0];
	
	
	always@( adr_i [ 5 : 2 ] or CtrlReg or StatReg or 
			PIO_cmdport_T1 or PIO_cmdport_T2 or PIO_cmdport_T4 or PIO_cmdport_Teoc or
			PIO_dport0_T1 or PIO_dport0_T2 or PIO_dport0_T4 or PIO_dport0_Teoc or
			PIO_dport1_T1 or PIO_dport1_T2 or PIO_dport1_T4 or PIO_dport1_Teoc or
			DMA_dev0_Tm or DMA_dev0_Td or DMA_dev0_Teoc or
			DMA_dev1_Tm or DMA_dev1_Td or DMA_dev1_Teoc or
			DMAq
		)
		case ( adr_i [ 5 : 2 ]) 
			 4'b0000: Q = CtrlReg;
			 4'b0001: Q = StatReg;
			 4'b0010 : Q = {PIO_cmdport_Teoc, PIO_cmdport_T4, PIO_cmdport_T2, PIO_cmdport_T1};
			 4'b0011 : Q = {PIO_dport0_Teoc, PIO_dport0_T4, PIO_dport0_T2, PIO_dport0_T1};
			 4'b0100 : Q = {PIO_dport1_Teoc, PIO_dport1_T4, PIO_dport1_T2, PIO_dport1_T1};
			 4'b0101: Q = {DMA_dev0_Teoc, 8'h0, DMA_dev0_Td, DMA_dev0_Tm};
			 4'b0110: Q = {DMA_dev1_Teoc, 8'h0, DMA_dev1_Td, DMA_dev1_Tm};
			 4'b1111: Q = DMAq;
			default: Q = 0;
		endcase

	
	assign dat_o =  adr_i [ 6 ] ? {16'h0, PIOq} : Q;

endmodule


`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\ro_cnt.v"




























































`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\timescale.v"
`timescale 1ns / 10ps


`line 61 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\ro_cnt.v"


module ro_cnt (clk, nReset, rst, cnt_en, go, done, d, q);

	
	parameter SIZE = 8;

	parameter UD = 1'b0;         
	parameter ID = {SIZE{1'b0}}; 

	
	input  clk;           
	input  nReset;        
	input  rst;           
	input  cnt_en;        
	input  go;            
	output done;          
	input  [SIZE-1:0] d;  
	output [SIZE-1:0] q;  

	
	reg rci;
	wire nld, rco;

	
	
	

	always@(posedge clk or negedge nReset)
		if (~nReset)
			rci <= #1 1'b0;
		else if (rst)
			rci <= #1 1'b0;
		else 
			rci <= #1 go | (rci & !rco);

	assign nld = !go;

	
	ud_cnt #(SIZE, ID) cnt (.clk(clk), .nReset(nReset), .rst(rst), .cnt_en(cnt_en),
		.ud(UD), .nld(nld), .d(d), .q(q), .rci(rci), .rco(rco));


	

	assign done = rco;

endmodule





`line 1 "C:\verilog\ata\ata\rtl\verilog\ocidec-1\timescale.v"
`timescale 1ns / 10ps



`line 1 "C:\verilog\ata\ata\bench\verilog\wb_slv_model.v"














































































`line 1 "C:\verilog\ata\ata\bench\verilog\wb_model_defines.v"

























































`timescale 1ns / 10ps

`line 79 "C:\verilog\ata\ata\bench\verilog\wb_slv_model.v"


module wb_slv(clk, rst, adr, din, dout, cyc, stb, sel, we, ack, err, rty);

input		clk, rst;
input	[31:0]	adr, din;
output	[31:0]	dout;
input		cyc, stb;
input	[3:0]	sel;
input		we;
output		ack, err, rty;






parameter	mem_size = 13;
parameter	sz = (1<<mem_size)-1;

reg	[31:0]	mem[sz:0];
wire		mem_re, mem_we;
wire	[31:0]	tmp;
reg	[31:0]	dout, tmp2;

reg		err, rty;
reg	[31:0]	del_ack;
reg	[5:0]	delay;






initial
   begin
	delay = 0;
	err = 0;
	rty = 0;
	#2;
	$display("\nINFO: WISHBONE MEMORY MODEL INSTANTIATED (%m)");
	$display("      Memory Size %0d address lines %0d words\n",
		mem_size, sz+1);
   end

assign mem_re = cyc & stb & !we;
assign mem_we = cyc & stb &  we;

assign	tmp = mem[adr[mem_size+1:2]];

always @(sel or tmp or mem_re or ack)
	if(mem_re & ack)
	   begin
		dout[31:24] <= #1 sel[3] ? tmp[31:24] : 8'hxx;
		dout[23:16] <= #1 sel[2] ? tmp[23:16] : 8'hxx;
		dout[15:08] <= #1 sel[1] ? tmp[15:08] : 8'hxx;
		dout[07:00] <= #1 sel[0] ? tmp[07:00] : 8'hxx;
	   end
	else	dout <= #1 32'hzzzz_zzzz;


always @(sel or tmp or din)
   begin
	tmp2[31:24] = !sel[3] ? tmp[31:24] : din[31:24];
	tmp2[23:16] = !sel[2] ? tmp[23:16] : din[23:16];
	tmp2[15:08] = !sel[1] ? tmp[15:08] : din[15:08];
	tmp2[07:00] = !sel[0] ? tmp[07:00] : din[07:00];
   end

always @(posedge clk)
	if(mem_we)	mem[adr[mem_size+1:2]] <= #1 tmp2;

always @(posedge clk)
	del_ack = ack ? 0 : {del_ack[30:0], (mem_re | mem_we)};

assign	#3 ack = cyc & ((delay==0) ? (mem_re | mem_we) : del_ack[delay-1]);

task fill_mem;
input		mode;

integer		n, mode;

begin

for(n=0;n<(sz+1);n=n+1)
   begin
	case(mode)
	   0:	mem[n] = { ~n[15:0], n[15:0] };
	   1:	mem[n] = $random;
	endcase
   end

end
endtask

endmodule


`line 1 "C:\verilog\ata\ata\bench\verilog\ata_device.v"
































































`timescale 1ns / 10ps

module ata_device(	ata_rst_, ata_data, ata_da, ata_cs0, ata_cs1,
			ata_dior_, ata_diow_, ata_iordy, ata_intrq );
input		ata_rst_;
inout	[15:0]	ata_data;
input	[2:0]	ata_da;
input		ata_cs0, ata_cs1;
input		ata_dior_, ata_diow_;
output		ata_iordy;
output		ata_intrq;

integer		mode;
integer		n;
reg		ata_iordy;
reg		iordy_enable;
integer		iordy_delay;

reg	[15:0]	mem[32:0];
reg	[15:0]	dout;
reg		dout_en;
wire		ata_rst_m0, ata_rst_m1, ata_rst_m2, ata_rst_m3, ata_rst_m4;
wire	[4:0]	addr;
wire		ata_dior, ata_diow;

initial
   begin
	dout_en = 0;
	mode = 0;
	iordy_enable = 0;
	iordy_delay  = 0;
	ata_iordy    = 1;
   end

assign ata_dior = !ata_dior_;
assign ata_diow = !ata_diow_;

assign ata_intrq = 0;

assign ata_data = dout_en ? dout : 16'hzzzz;

assign addr = {~ata_cs1, ~ata_cs0, ata_da};

always @(posedge ata_rst_)
	dout_en = 0;

always @(posedge ata_dior)
   begin
	dout = mem[ addr ];
	dout_en = 1;
   end

always @(posedge ata_dior)
   begin
	dout_en = 0;
   end

always @(posedge ata_diow)
   begin
	mem[ addr ] = ata_data;
   end

always @(posedge ata_dior or posedge ata_diow)
   begin
	ata_iordy = 1'b0;
	#(iordy_delay);
	ata_iordy = 1'b1;
   end

task init_mem;

begin

for(n=0;n<32;n=n+1)
	mem[n] = n;
end
endtask

assign ata_rst_m0 = ata_rst_ & (mode==0);
assign ata_rst_m1 = ata_rst_ & (mode==1);
assign ata_rst_m2 = ata_rst_ & (mode==2);
assign ata_rst_m3 = ata_rst_ & (mode==3);
assign ata_rst_m4 = ata_rst_ & (mode==4);


























































































































































































































































endmodule




`line 1 "C:\verilog\ata\ata\bench\verilog\test_bench_top.v"































































`timescale 1ns / 10ps

module test;

reg		clk;
reg		rst;

wire		int;
wire	[31:0]	wb_addr_i;
wire	[31:0]	wb_data_i;
wire	[31:0]	wb_data_o;
wire	[3:0]	wb_sel_i;
wire		wb_we_i;
wire		wb_stb_i;
wire		wb_cyc_i;
wire		wb_ack_o;
wire		wb_err_o;

wire		ata_rst_;
wire	[15:0]	ata_dout;
wire	[15:0]	ata_din;
wire	[15:0]	ata_data;
wire		ata_doe;
wire	[2:0]	ata_da;
wire		ata_cs0, ata_cs1;
wire		ata_dior, ata_diow;
wire		ata_iordy;
wire		ata_intrq;
reg		ata_intrq_r;



integer		wd_cnt;
integer		error_cnt;
integer		verbose;


















initial
   begin
	$display("\n\n");
	$display("******************************************************");
	$display("* WISHBONE ATA 1 Controller Simulation started ...   *");
	$display("******************************************************");
	$display("\n");





	wd_cnt = 0;
	error_cnt = 0;
   	clk = 0;
   	rst = 0;
	verbose = 1;
	ata_intrq_r=0;

   	repeat(10)	@(posedge clk);
   	rst = 1;
   	repeat(10)	@(posedge clk);

	

if(1)	
   begin
	io_test1;
	io_test2;
	int_test;
	rst_test;

   end
else
   begin

	
	
	
$display("\n\n");
$display("*****************************************************");
$display("*** DEVELOPMENT Test                              ***");
$display("*****************************************************\n");




show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

   end
   	repeat(100)	@(posedge clk);
   	$finish;
   end






always #5	clk = ~clk;







always @(wb_cyc_i or wb_ack_o)
	wd_cnt <= #5 0;

always @(posedge clk)
	wd_cnt <= #1 wd_cnt + 1;

always @(wd_cnt)
	if(wd_cnt>5000)
	   begin
		$display("\n\n*************************************\n");
		$display("ERROR: Watch Dog Counter Expired\n");
		$display("*************************************\n\n\n");
		$finish;
	   end







assign ata_din  = ata_data;
assign ata_data = ata_doe ? ata_dout : 16'hzzzz;


atahost_top u0(	
		.wb_clk_i(		clk		),
		.arst_i(		rst		),
		.wb_rst_i(		~rst		),

		
		.wb_cyc_i(		wb_cyc_i	),
		.wb_stb_i(		wb_stb_i	),
		.wb_ack_o(		wb_ack_o	),
		.wb_err_o(		wb_err_o	),
		.wb_adr_i(		wb_addr_i[6:2]	),
		.wb_dat_i(		wb_data_i	),
		.wb_dat_o(		wb_data_o	),
		.wb_sel_i(		wb_sel_i	),
		.wb_we_i(		wb_we_i		),
		.wb_inta_o(		int		),

		
		.resetn_pad_o(	ata_rst_	),
		.dd_pad_i(		ata_din		),
		.dd_pad_o(		ata_dout	),
		.dd_padoe_o(		ata_doe		),
		.da_pad_o(		ata_da		),
		.cs0n_pad_o(	ata_cs0		),
		.cs1n_pad_o(	ata_cs1		),
		.diorn_pad_o(	ata_dior_	),
		.diown_pad_o(	ata_diow_	),
		.iordy_pad_i(	ata_iordy	),
		.intrq_pad_i(	ata_intrq_r	)
		);


ata_device a0(	.ata_rst_(	ata_rst_	),
		.ata_data(	ata_data	),
		.ata_da(	ata_da		),
		.ata_cs0(	ata_cs0		),
		.ata_cs1(	ata_cs1		),
		.ata_dior_(	ata_dior_	),
		.ata_diow_(	ata_diow_	),
		.ata_iordy(	ata_iordy	),
		.ata_intrq(	ata_intrq	) );


wb_mast	m0(	.clk(		clk		),
		.rst(		rst		),
		.adr(		wb_addr_i	),
		.din(		wb_data_o	),
		.dout(		wb_data_i	),
		.cyc(		wb_cyc_i	),
		.stb(		wb_stb_i	),
		.sel(		wb_sel_i	),
		.we(		wb_we_i		),
		.ack(		wb_ack_o	),
		.err(		wb_err_o	),
		.rty(		1'b0		) );


`line 1 "C:\verilog\ata\ata\bench\verilog\tests.v"





























































task show_errors;
begin

$display("\n");
$display("     +--------------------+");
$display("     |  Total ERRORS: %0d   |", error_cnt);
$display("     +--------------------+");

end
endtask


task reg_test;

reg	[31:0]	data;
reg	[31:0]	pattern;
integer		n;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** Register Test                                 ***");
$display("*****************************************************\n");



show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask



task io_test1;

reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
reg	[31:0]	data3;
integer		n;
integer		id;
integer		del;
integer		del_max;
integer		iordy_del;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** IO Test 1                                     ***");
$display("*** Testing WISHBONE wait state insertion, and    ***");
$display("*** iordy assertion.                              ***");
$display("*****************************************************\n");

id = 0;
del_max = 16;
for(del=0;del<del_max;del=del+1)
for(id=0;id<2;id=id+1)
begin
	if(!verbose)
	$display("*** MODE SELECT: 'iordy' enable: %0d, wb-delay: %0d\n", id, del);

for(iordy_del=0;iordy_del<(id ? 600 : 1);iordy_del=iordy_del+10)
   begin

	if(verbose)
	$display("*** MODE SELECT: 'iordy' enable: %0d, wb-delay: %0d iordy_del: %0d\n",
		id, del, iordy_del);

	a0.iordy_enable = id;
	a0.iordy_delay = 600;	
	a0.init_mem;

	if(id==1)	data1 = 32'h0000_0082;
	else		data1 = 32'h0000_0080;
	m0.wb_wr1(  32'h0000_0000, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0000, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	m0.wb_rd1(  32'h0000_0008, 4'hf, data );

   	repeat(10)	@(posedge clk);

	
	if(verbose)	$display(">>> Running Read Only test 1 ... (%0t)", $time);
	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_rd1(  32'h0000_0040 + (n*4) , 4'hf, data );
		if(data[15:0] != (n+8) )
		   begin
			$display("ERROR: Read 1 Mismatch: Expected: %h Got: %h (%0t)",
				(n+8), data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");

	
	if(verbose)	$display(">>> Running Read/Write test 1 ... (%0t)", $time);

	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_wr1(  32'h0000_0040 + (n*4) , 4'hf, ~n[15:0] );
		if(a0.mem[n+8] != ~n[15:0] )
		   begin
			$display("ERROR: Write 1 Mismatch: Expected: %h Got: %h (%0t)",
				~n[15:0], a0.mem[n+8], $time);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_rd1(  32'h0000_0040 + (n*4) , 4'hf, data );
		if(data[15:0] != ~n[15:0] )
		   begin
			$display("ERROR: Read 2 Mismatch: Expected: %h Got: %h (%0t)",
				~n[15:0], data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");

	
	if(verbose)	$display(">>> Running Read/Write test 2 ... (%0t)", $time);

	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_wr1(  32'h0000_0040 + (n*4) , 4'hf, n[15:0] );
		m0.wb_rd1(  32'h0000_0040 + (n*4) , 4'hf, data );
		if(data[15:0] != n[15:0] )
		   begin
			$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%0t)",
				n[15:0], data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");


	
	if(verbose)	$display(">>> Running Read/Write test 3 ... (%0t)", $time);

	for(n=0;n<16;n=n+4)
	   begin
		m0.wb_wr4(  32'h0000_0040 + (n*4) , 4'hf, del,
				{16'h0, ~n[13:0], 2'h3},
				{16'h0, ~n[13:0], 2'h2},
				{16'h0, ~n[13:0], 2'h1},
				{16'h0, ~n[13:0], 2'h0}		);

		m0.wb_rd4(  32'h0000_0040 + (n*4) , 4'hf, del, data, data1, data2, data3 );

		if(	(data[15:0]  != {~n[13:0], 2'h3}) |
			(data1[15:0] != {~n[13:0], 2'h2}) |
			(data2[15:0] != {~n[13:0], 2'h1}) |
			(data3[15:0] != {~n[13:0], 2'h0}) )
		   begin
			$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%0t)",
				n[15:0], data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");


	
	if(verbose)	$display(">>> Running Read/Write test 4 (RMW) ... (%0t)", $time);

	a0.init_mem;

	for(n=0;n<16;n=n+1)
	   begin
		m0.wr_mem[n] = n[15:0];
		m0.wb_rmw(  32'h0000_0040 + (n*4) , 4'hf, del, 1, 1);
		data = m0.rd_mem[n];

		data2[15:0] =  n[15:0] + 8;

		data1 = a0.mem[n+8];
		data3 = n[15:0];

		if(	(data[15:0]  != data2[15:0] ) |
			(data1[15:0] != data3[15:0]) )
		   begin
			$display("ERROR: Read 4a Mismatch: Expected: %h Got: %h (%0t)",
				data2[15:0], data[15:0], $time);
			$display("ERROR: Read 4b Mismatch: Expected: %h Got: %h (%0t)",
				data1[15:0], data3[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");

   end
end

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask


task io_test2;

reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
reg	[31:0]	data3;
integer		n;
integer		id;
integer		del;
integer		del_max;
integer		pio_mode;
integer		iordy_del;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** IO Test 2                                     ***");
$display("*** Testing PIO Modes, iordy assertion and        ***");
$display("*** iordy delays.                                 ***");
$display("*****************************************************\n");

id = 0;
del = 1;
verbose = 0;
iordy_del = 0;
pio_mode=4;

for(pio_mode=0;pio_mode<5;pio_mode=pio_mode+1)
for(id=0;id<2;id=id+1)
begin
	if(!verbose)
	$display("*** MODE SELECT: PIO mode: %0d iordy enable: %0d", pio_mode, id);

for(iordy_del=0;iordy_del < (id ? 600 : 1); iordy_del=iordy_del+1)
   begin

	if(verbose)
	$display("*** MODE SELECT: PIO mode: %0d, 'iordy' enable: %0d iordy del: %0d\n",
		pio_mode, id, iordy_del );

	a0.mode = pio_mode;
	a0.iordy_enable = id;
	a0.iordy_delay = iordy_del;	
	a0.init_mem;

	data1 = 32'h0000_0001;
	m0.wb_wr1(  32'h0000_0000, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0000, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	data1 = 32'h1000_0000;
	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: STAT Register read Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	case(pio_mode)
	   0: data1 = {8'h18, 8'h02, 8'h1c, 8'h04};	
	   1: data1 = {8'h05, 8'h01, 8'h1c, 8'h02};	
	   2: data1 = {8'h01, 8'h01, 8'h1c, 8'h00};	
	   3: data1 = {8'h07, 8'h00, 8'h07, 8'h00};	
	   4: data1 = {8'h02, 8'h00, 8'h06, 8'h00};	
	endcase
	m0.wb_wr1(  32'h0000_0008, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0008, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: PCTR Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	if(id==1)	data1 = 32'h0000_0082;
	else		data1 = 32'h0000_0080;
	m0.wb_wr1(  32'h0000_0000, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0000, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

   	repeat(10)	@(posedge clk);

	
	if(verbose)	$display(">>> Running Read Only test 1 ... (%0t)", $time);
	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_rd1(  32'h0000_0040 + (n*4) , 4'hf, data );
		if(data[15:0] != (n+8) )
		   begin
			$display("ERROR: Read 1 Mismatch: Expected: %h Got: %h (%0t)",
				(n+8), data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");

	
	if(verbose)	$display(">>> Running Read/Write test 1 ... (%0t)", $time);

	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_wr1(  32'h0000_0040 + (n*4) , 4'hf, ~n[15:0] );
		if(a0.mem[n+8] != ~n[15:0] )
		   begin
			$display("ERROR: Write 1 Mismatch: Expected: %h Got: %h (%0t)",
				~n[15:0], a0.mem[n+8], $time);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_rd1(  32'h0000_0040 + (n*4) , 4'hf, data );
		if(data[15:0] != ~n[15:0] )
		   begin
			$display("ERROR: Read 2 Mismatch: Expected: %h Got: %h (%0t)",
				~n[15:0], data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");

	
	if(verbose)	$display(">>> Running Read/Write test 2 ... (%0t)", $time);

	for(n=0;n<16;n=n+1)
	   begin
		m0.wb_wr1(  32'h0000_0040 + (n*4) , 4'hf, n[15:0] );
		m0.wb_rd1(  32'h0000_0040 + (n*4) , 4'hf, data );
		if(data[15:0] != n[15:0] )
		   begin
			$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%0t)",
				n[15:0], data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");


	
	if(verbose)	$display(">>> Running Read/Write test 3 ... (%0t)", $time);

	for(n=0;n<16;n=n+4)
	   begin
		m0.wb_wr4(  32'h0000_0040 + (n*4) , 4'hf, del,
				{16'h0, ~n[13:0], 2'h3},
				{16'h0, ~n[13:0], 2'h2},
				{16'h0, ~n[13:0], 2'h1},
				{16'h0, ~n[13:0], 2'h0}		);

		m0.wb_rd4(  32'h0000_0040 + (n*4) , 4'hf, del, data, data1, data2, data3 );

		if(	(data[15:0]  != {~n[13:0], 2'h3}) |
			(data1[15:0] != {~n[13:0], 2'h2}) |
			(data2[15:0] != {~n[13:0], 2'h1}) |
			(data3[15:0] != {~n[13:0], 2'h0}) )
		   begin
			$display("ERROR: Read 3 Mismatch: Expected: %h Got: %h (%0t)",
				n[15:0], data[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");


	
	if(verbose)	$display(">>> Running Read/Write test 4 (RMW) ... (%0t)", $time);

	a0.init_mem;

	for(n=0;n<16;n=n+1)
	   begin
		m0.wr_mem[n] = n[15:0];
		m0.wb_rmw(  32'h0000_0040 + (n*4) , 4'hf, del, 1, 1);
		data = m0.rd_mem[n];

		data2[15:0] =  n[15:0] + 8;

		data1 = a0.mem[n+8];
		data3 = n[15:0];

		if(	(data[15:0]  != data2[15:0] ) |
			(data1[15:0] != data3[15:0]) )
		   begin
			$display("ERROR: Read 4a Mismatch: Expected: %h Got: %h (%0t)",
				data2[15:0], data[15:0], $time);
			$display("ERROR: Read 4b Mismatch: Expected: %h Got: %h (%0t)",
				data1[15:0], data3[15:0], $time);
			error_cnt = error_cnt + 1;
		   end
	   end
	if(verbose)	$display("");

   end
end


show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask



task rst_test;
reg	[31:0]	data;
reg	[31:0]	data1;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** RST Test                                      ***");
$display("***                                               ***");
$display("*****************************************************\n");


	a0.iordy_enable = 0;
	a0.iordy_delay = 0;	
	a0.init_mem;

	data1 = 32'h0000_0080;
	m0.wb_wr1(  32'h0000_0000, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0000, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	m0.wb_rd1(  32'h0000_0008, 4'hf, data );

	if(ata_rst_ !== 1'b1)
	   begin
		$display("ERROR: ATA Reset not deasserted ... (%0t)", $time);
		error_cnt = error_cnt + 1;
	   end
   	repeat(500)	@(posedge clk);

	data1[0] = 1;
	m0.wb_wr1(  32'h0000_0000, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0000, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

   	repeat(100)
	   begin
		if(ata_rst_ !== 1'b0)
		   begin
			$display("ERROR: ATA Reset not asserted ... (%0t)", $time);
			error_cnt = error_cnt + 1;
		   end

		@(posedge clk);
	   end

	data1[0] = 0;
	m0.wb_wr1(  32'h0000_0000, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0000, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	if(ata_rst_ !== 1'b1)
	   begin
		$display("ERROR: ATA Reset not deasserted ... (%0t)", $time);
		error_cnt = error_cnt + 1;
	   end

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask



task int_test;
reg	[31:0]	data;
reg	[31:0]	data1;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** INT Test                                      ***");
$display("***                                               ***");
$display("*****************************************************\n");

	a0.iordy_enable = 0;
	a0.iordy_delay = 0;
	a0.init_mem;

	data1 = 32'h0000_0080;
	m0.wb_wr1(  32'h0000_0000, 4'hf, data1);
	m0.wb_rd1(  32'h0000_0000, 4'hf, data );
	if(data != data1 )
	   begin
		$display("ERROR: CTRL Register write Mismatch: Expected: %h Got: %h (%0t)",
			data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	
	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	data1 = 32'h1000_0000;
	if(data !== data1)
	   begin
		$display("ERROR: ATA STATUS mismatch (1), Expected: %0h Got: %0h (%0t)", $time, data1, data);
		error_cnt = error_cnt + 1;
	   end

   	repeat(20)	@(posedge clk);

	
	
	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	data1 = 32'h1000_0000;
	if(data !== data1)
	   begin
		$display("ERROR: ATA STATUS mismatch (2), Expected: %0h Got: %0h (%0t)", $time, data1, data);
		error_cnt = error_cnt + 1;
	   end

	
	ata_intrq_r = 1;
   	repeat(10)	@(posedge clk);
	ata_intrq_r = 0;


	
	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	data1 = 32'h1000_0001;
	if(data !== data1)
	   begin
		$display("ERROR: ATA STATUS mismatch (3), Expected: %0h Got: %0h (%0t)", data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

   	repeat(10)	@(posedge clk);

	
	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	data1 = 32'h1000_0001;
	if(data !== data1)
	   begin
		$display("ERROR: ATA STATUS mismatch (4), Expected: %0h Got: %0h (%0t)", data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	
	data1 = 32'h0000_0000;
	m0.wb_wr1(  32'h0000_0004, 4'hf, data1 );


	
	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	data1 = 32'h1000_0000;
	if(data !== data1)
	   begin
		$display("ERROR: ATA STATUS mismatch (5), Expected: %0h Got: %0h (%0t)", data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

	
	m0.wb_rd1(  32'h0000_0004, 4'hf, data );
	data1 = 32'h1000_0000;
	if(data !== data1)
	   begin
		$display("ERROR: ATA STATUS mismatch (6), Expected: %0h Got: %0h (%0t)", data1, data, $time);
		error_cnt = error_cnt + 1;
	   end

   	repeat(100)	@(posedge clk);

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask



`line 269 "C:\verilog\ata\ata\bench\verilog\test_bench_top.v"


endmodule




`line 1 "C:\verilog\ata\ata\bench\verilog\wb_mast_model.v"


























































































































`line 1 "C:\verilog\ata\ata\bench\verilog\wb_model_defines.v"

























































`timescale 1ns / 10ps

`line 123 "C:\verilog\ata\ata\bench\verilog\wb_mast_model.v"


module wb_mast(clk, rst, adr, din, dout, cyc, stb, sel, we, ack, err, rty);

input		clk, rst;
output	[31:0]	adr;
input	[31:0]	din;
output	[31:0]	dout;
output		cyc, stb;
output	[3:0]	sel;
output		we;
input		ack, err, rty;






parameter mem_size = 4096;

reg	[31:0]	adr;
reg	[31:0]	dout;
reg		cyc, stb;
reg	[3:0]	sel;
reg		we;

reg	[31:0]	rd_mem[mem_size:0];
reg	[31:0]	wr_mem[mem_size:0];
integer		rd_cnt;
integer		wr_cnt;






initial
   begin
	adr = 32'hxxxx_xxxx;
	dout = 32'hxxxx_xxxx;
	cyc = 0;
	stb = 0;
	sel = 4'hx;
	we = 1'hx;
	rd_cnt = 0;
	wr_cnt = 0;
	#1;
	$display("\nINFO: WISHBONE MASTER MODEL INSTANTIATED (%m)\n");
   end



task mem_fill;

integer n;
begin
rd_cnt = 0;
wr_cnt = 0;
for(n=0;n<mem_size;n=n+1)
   begin
	rd_mem[n] = $random;
	wr_mem[n] = $random;
   end
end
endtask






task wb_wr1;
input	[31:0]	a;
input	[3:0]	s;
input	[31:0]	d;

begin

@(posedge clk);
#1;
adr = a;
dout = d;
cyc = 1;
stb = 1;
we=1;
sel = s;

@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#1;
cyc=0;
stb=0;
adr = 32'hxxxx_xxxx;
dout = 32'hxxxx_xxxx;
we = 1'hx;
sel = 4'hx;

end
endtask






task wb_wr4;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input	[31:0]	d1;
input	[31:0]	d2;
input	[31:0]	d3;
input	[31:0]	d4;

integer		delay;

begin

@(posedge clk);
#1;
cyc = 1;
sel = s;

repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
adr = a;
dout = d1;
stb = 1;
we=1;
while(~ack & ~err)	@(posedge clk);
#2;
stb=0;
we=1'bx;
dout = 32'hxxxx_xxxx;
adr = 32'hxxxx_xxxx;

repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
stb=1;
adr = a+4;
dout = d2;
we=1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#2;
stb=0;
we=1'bx;
dout = 32'hxxxx_xxxx;
adr = 32'hxxxx_xxxx;

repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
stb=1;
adr = a+8;
dout = d3;
we=1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#2;
stb=0;
we=1'bx;
dout = 32'hxxxx_xxxx;
adr = 32'hxxxx_xxxx;

repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
stb=1;
adr = a+12;
dout = d4;
we=1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#1;
stb=0;
cyc=0;

adr = 32'hxxxx_xxxx;
dout = 32'hxxxx_xxxx;
we = 1'hx;
sel = 4'hx;

end
endtask


task wb_wr_mult;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input		count;

integer		delay;
integer		count;
integer		n;

begin

@(posedge clk);
#1;
cyc = 1;

for(n=0;n<count;n=n+1)
   begin
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	adr = a + (n*4);
	dout = wr_mem[n + wr_cnt];
	stb = 1;
	we=1;
	sel = s;
	if(n!=0)	@(posedge clk);
	while(~ack & ~err)	@(posedge clk);
	#2;
	stb=0;
	we=1'bx;
	sel = 4'hx;
	dout = 32'hxxxx_xxxx;
	adr = 32'hxxxx_xxxx;
   end

cyc=0;
adr = 32'hxxxx_xxxx;

wr_cnt = wr_cnt + count;
end
endtask


task wb_rmw;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input		rcount;
input		wcount;

integer		delay;
integer		rcount;
integer		wcount;
integer		n;

begin

@(posedge clk);
#1;
cyc = 1;
we = 0;
sel = s;
repeat(delay)	@(posedge clk);

for(n=0;n<rcount-1;n=n+1)
   begin
	adr = a + (n*4);
	stb = 1;
	while(~ack & ~err)	@(posedge clk);
	rd_mem[n + rd_cnt] = din;
	
	#2;
	stb=0;
	we = 1'hx;
	sel = 4'hx;
	adr = 32'hxxxx_xxxx;
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	we = 0;
	sel = s;
   end

adr = a+(n*4);
stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
rd_mem[n + rd_cnt] = din;

#1;
stb=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hxxxx_xxxx;

rd_cnt = rd_cnt + rcount;

for(n=0;n<wcount;n=n+1)
   begin
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	adr = a + (n*4);
	dout = wr_mem[n + wr_cnt];
	stb = 1;
	we=1;
	sel = s;

		@(posedge clk);
	while(~ack & ~err)	@(posedge clk);
	#2;
	stb=0;
	we=1'bx;
	sel = 4'hx;
	dout = 32'hxxxx_xxxx;
	adr = 32'hxxxx_xxxx;
   end

cyc=0;
adr = 32'hxxxx_xxxx;

wr_cnt = wr_cnt + wcount;
end
endtask








task wb_rd1;
input	[31:0]	a;
input	[3:0]	s;
output	[31:0]	d;

begin

@(posedge clk);
#1;
adr = a;
cyc = 1;
stb = 1;
we  = 0;
sel = s;

while(~ack & ~err)	@(posedge clk);
d = din;
#1;
cyc=0;
stb=0;
adr = 32'hxxxx_xxxx;
dout = 32'hxxxx_xxxx;
we = 1'hx;
sel = 4'hx;

end
endtask








task wb_rd4;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
output	[31:0]	d1;
output	[31:0]	d2;
output	[31:0]	d3;
output	[31:0]	d4;

integer		delay;
begin

@(posedge clk);
#1;
cyc = 1;
we = 0;
sel = s;
repeat(delay)	@(posedge clk);

adr = a;
stb = 1;
while(~ack & ~err)	@(posedge clk);
d1 = din;
#2;
stb=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hxxxx_xxxx;
repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
we = 0;
sel = s;

adr = a+4;
stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
d2 = din;
#2;
stb=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hxxxx_xxxx;
repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
we = 0;
sel = s;


adr = a+8;
stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
d3 = din;
#2;
stb=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hxxxx_xxxx;
repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
we = 0;
sel = s;

adr = a+12;
stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
d4 = din;
#1;
stb=0;
cyc=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hxxxx_xxxx;
end
endtask


task wb_rd_mult;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input		count;

integer		delay;
integer		count;
integer		n;

begin

@(posedge clk);
#1;
cyc = 1;
we = 0;
sel = s;
repeat(delay)	@(posedge clk);

for(n=0;n<count-1;n=n+1)
   begin
	adr = a + (n*4);
	stb = 1;
	while(~ack & ~err)	@(posedge clk);
	rd_mem[n + rd_cnt] = din;
	#2;
	stb=0;
	we = 1'hx;
	sel = 4'hx;
	adr = 32'hxxxx_xxxx;
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	we = 0;
	sel = s;
   end

adr = a+(n*4);
stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
rd_mem[n + rd_cnt] = din;
#1;
stb=0;
cyc=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hxxxx_xxxx;

rd_cnt = rd_cnt + count;
end
endtask

endmodule


`line 1 "C:\verilog\ata\ata\bench\verilog\wb_model_defines.v"

























































`timescale 1ns / 10ps



